(* 
   Un insieme finito e' un tipo di dato strutturato, 'a set, della forma 
   {x1,...,xn}, per n>=0, a componenti xi omogenei e contenente al piu'
   un'occorrenza di uno stesso valore, xi=xj iff i=j. 
   I valori 'a set sono valori Immutable, sui quali possiamo operare me-
   diante le sole seguenti operazioni nell'API SET.
   Si dia un ADT, con nome Set1. Allo scopo, si fornisca:
   (1) Stato della Rappresentazione, AF ed I: Non si sovraccarichi la rappresentazione 
   	   con duplicati di elementi;
   (2) Definizione delle operazioni espressamente indicate;
   (3) Esecuzione e verifica comportamento
 *)

module type SET =
 sig type 'a set 
  val mk: unit -> 'a set
  exception InvalidArgException of string
  val addAll: 'a set -> 'a list -> 'a set
  (* public additional *)
  val toString: 'a set -> ('a -> string) -> string
end;;

module Set1 =
(struct 
   ...
   (*
    AF(c) = ...
    I(c) = ...
   *)
   exception InvalidArgException of string
   let mk() = ...
   let ...
   let ...
 (* additionals *)
   let ...
   let ...
end:SET);;

open Printf;;
...

